/* ============================================================================
    Copyright (C) 2010 nomrasco
    Nom Rasco <nomrasco@gmail.com>

    This file is part of libnomaccel.

    libnomaccel is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    libnomaccel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with libnomaccel.  If not, see <http://www.gnu.org/licenses/>.
============================================================================ */
#ifndef _NOM_NEUTRAL_SETTINGS_H_
#define _NOM_NEUTRAL_SETTINGS_H_
#include "accel.h"

typedef enum {
	NOM_ACCEL_ZERO_NEUTRAL = 0,
	NOM_ACCEL_LOCAL_NEUTRAL,
	NOM_ACCEL_SYSTEM_NEUTRAL,
	NOM_ACCEL_SETTINGS_NUMBER
} NomAccelNeutralSetting;

NomAccelNeutralSetting nom_accel_nsettings_get_current ();
void  nom_accel_nsettings_set_current (NomAccelNeutralSetting settings);

void  nom_accel_nsettings_set_neutral_pitch ( NomAccelNeutralSetting settings,
                                              angle new_pitch );
void  nom_accel_nsettings_set_neutral_roll  ( NomAccelNeutralSetting settings,
                                              angle new_roll );

angle nom_accel_nsettings_get_neutral_pitch (NomAccelNeutralSetting settings);
angle nom_accel_nsettings_get_neutral_roll  (NomAccelNeutralSetting settings);


#endif
