/* ============================================================================
    Copyright (C) 2010 nomrasco
    Nom Rasco <nomrasco@gmail.com>

    This file is part of libnomaccel.

    libnomaccel is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    libnomaccel is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with libnomaccel.  If not, see <http://www.gnu.org/licenses/>.
============================================================================ */
#ifndef _NOM_ACCELEROMETER_H_
#define _NOM_ACCELEROMETER_H_

typedef int   value;
typedef float angle;

typedef struct {
	value x;
	value y;
	value z;
	angle pitch;
	angle roll;
} NomAccelCache;

/* simplest retrieving functions: x,y,z,pitch,roll */
value nom_accel_get_x ();
value nom_accel_get_y ();
value nom_accel_get_z ();
void  nom_accel_get_xyz (value* x, value* y, value* z);

angle nom_accel_get_pitch ();
angle nom_accel_get_roll  ();
void  nom_accel_get_pitch_roll (angle* pitch, angle* roll);

void  nom_accel_get_all ( value* x, value* y, value* z,
                          angle* pitch, angle* roll     );


void    nom_accel_cache_get  (NomAccelCache* put_to);
#define nom_accel_cache_get_x(cache)     ((cache)->x)
#define nom_accel_cache_get_y(cache)     ((cache)->y)
#define nom_accel_cache_get_z(cache)     ((cache)->z)
#define nom_accel_cache_get_pitch(cache) ((cache)->pitch)
#define nom_accel_cache_get_roll(cache)  ((cache)->roll)

#endif
